#include <Application.h>
#include <Window.h>
#include <Menu.h>
#include <MenuBar.h>
#include <MenuItem.h>

#include <Alert.h>

#include <StringView.h>

#include <stdio.h>
#include <stdlib.h>
#include <complex>

#include <math.h>

#define f(x0) pow(x0, roots)-1
#define ff(x0) roots*(pow(x0, roots-1))

#define MENU_BAR_HEIGHT 18.0

#define OTHER_ROOT 0
#define ABOUT_NEWT 1



class NewtonApplication : public BApplication {
public:
	NewtonApplication();
};




class NewtonView : public BView {
public:
  NewtonView(BRect frame, const char *name); 
  virtual	void Draw(BRect updateRect);
  virtual void UpdateMe();
	
  typedef std::complex<double> complex;
  complex x0;
  complex x1;
  
  int matrix[200][200];				//ugly ugly, fix later.
  
  int roots;
  
};

class NewtonWindow : public BWindow {
public:
  NewtonWindow(BRect frame);
  virtual void		MessageReceived(BMessage *message);
  virtual bool		QuitRequested();
  NewtonView *aView;					// bad style?? who cares?
  BRect aRect;
};



void NewtonView::UpdateMe() {


  // super ugly, repeat the same functionalty as in the constructor
  // fix later.
  
  x0=complex(0.0, 0.0);
  x1=complex(0.0, 0.0);

  double tol=0.0001;
  double rr[roots];
  double ir[roots];
  double delta_angle=2*PI/roots;
  double cuml_angle=0;


//busy busy
  for(int ang_loop=0; ang_loop<roots; ang_loop++) {	//calculate the sol'ns at each of the roots
    rr[ang_loop]=cos(cuml_angle);
    ir[ang_loop]=sin(cuml_angle);
    printf("angle %f %f %f\n", cuml_angle/PI, rr[ang_loop], ir[ang_loop]);
    cuml_angle+=delta_angle;
  }

    for(float i=-1;i<1;i+=0.01) {
     for(float j=-1; j<1; j+=0.01) {
      x0=complex(i,j);
      for(int n=0;n<100;n++) {
        x1=complex(x0)-complex(f(x0))/complex(ff(x0));
        x0=complex(x1);
      }

      //new method to assign root number, hopefully scales better.
      for (int root_count=0; root_count<roots; root_count++) {
        if( (fabs(real(x0)-rr[root_count]) < tol) && (fabs(imag(x0)-ir[root_count]) < tol) )
          matrix[int(i*100)+100][int(j*100)+100]=root_count+1;
      }

    }
  }
//busy busy


}

NewtonView::NewtonView(BRect rect, const char *name)
	   	   : BView(rect, name, B_FOLLOW_ALL, B_WILL_DRAW)
{

  SetFont(be_bold_font);
  SetFontSize(16);

  SetHighColor(25,0,0);
  SetLowColor(255,255,255);
  SetViewColor(255,255,255);
	
  for(int ii=0; ii<200; ii++) {		// define a matrix that will hold colour value of each pixel.
    for(int jj=0; jj<200; jj++) {
      matrix[ii][jj]=0;
    }
  }
  
  x0=complex(0.0, 0.0);
  x1=complex(0.0, 0.0);

  double tol=0.0001;
  roots=6;
  double rr[roots];
  double ir[roots];
  double delta_angle=2*PI/roots;
  double cuml_angle=0;


//busy busy
  for(int ang_loop=0; ang_loop<roots; ang_loop++) {	//calculate the sol'ns at each of the roots
    rr[ang_loop]=cos(cuml_angle);
    ir[ang_loop]=sin(cuml_angle);
    printf("angle %f %f %f\n", cuml_angle/PI, rr[ang_loop], ir[ang_loop]);
    cuml_angle+=delta_angle;
  }

    for(float i=-1;i<1;i+=0.01) {
     for(float j=-1; j<1; j+=0.01) {
      x0=complex(i,j);
      for(int n=0;n<100;n++) {
        x1=complex(x0)-complex(f(x0))/complex(ff(x0));
        x0=complex(x1);
      }

      //new method to assign root number, hopefully scales.
      for (int root_count=0; root_count<roots; root_count++) {
        if( (fabs(real(x0)-rr[root_count]) < tol) && (fabs(imag(x0)-ir[root_count]) < tol) )
          matrix[int(i*100)+100][int(j*100)+100]=root_count+1;
      }

    }
  }
//busy busy


}



void NewtonView::Draw(BRect) {


  int i=0, j=0;


  struct col_struct {
    int r;
    int g;
    int b;
  };
  
  
  struct col_struct colours[roots];
  struct col_struct temp_colour_struct;

  
  colours[0].r=0; colours[0].g=0; colours[0].b=0;	//colour[0] should be black
  for (int colour_loop=1; colour_loop<roots; colour_loop++) {	//make an array with random colours, roots times
    temp_colour_struct.r=int((double(rand())/RAND_MAX)*256);	//if we have more than 6 roots, make up a random
    temp_colour_struct.g=int((double(rand())/RAND_MAX)*256);
    temp_colour_struct.b=int((double(rand())/RAND_MAX)*256);
    
    colours[colour_loop] = temp_colour_struct;
  }

    	
    for(i=0; i<200; i++) {
      for(j=0; j<200; j++) {
        if(matrix[i][j]==0) SetHighColor(0,0,0);		//black
        else if(matrix[i][j]==1) SetHighColor(0,255,0); //green
        else if(matrix[i][j]==2) SetHighColor(255,0,0); //red
        else if(matrix[i][j]==3) SetHighColor(0,0,255); //blue
        else if(matrix[i][j]==4) SetHighColor(255,125,0); //orange
        else if(matrix[i][j]==5) SetHighColor(15,225,255);
        else if(matrix[i][j]==6) SetHighColor(200,30,150);

        else SetHighColor(colours[matrix[i][j]].r, colours[matrix[i][j]].g, colours[matrix[i][j]].b);
        StrokeLine(BPoint(i,j), BPoint(i,j), B_SOLID_HIGH);


      }
    }

}


NewtonWindow::NewtonWindow(BRect frame)
				: BWindow(frame, "Newton", B_TITLED_WINDOW, B_NOT_RESIZABLE )
{
	frame.OffsetTo(B_ORIGIN);
	frame.top += MENU_BAR_HEIGHT + 5.0;

//	NewtonView	*aView;
//	BRect aRect( Bounds() );
    aRect = Bounds();
	aRect.top = MENU_BAR_HEIGHT + 2.0;
	
	aView = new NewtonView(aRect, "NewtonView");
	AddChild(aView);
	
	
	BMenu *filemenu;
	BMenu *rootsmenu;
	BMenuBar *fMenuBar;
	BRect menuBarRect;
	
	menuBarRect.Set(0.0, 0.0, 10000.0, MENU_BAR_HEIGHT);
	fMenuBar = new BMenuBar(menuBarRect, "MenuBar");
	AddChild(fMenuBar);
	
	
	filemenu = new BMenu("File");
	fMenuBar->AddItem(filemenu);

	rootsmenu = new BMenu("Roots");
	fMenuBar->AddItem(rootsmenu);

    filemenu->AddItem(new BMenuItem("About", new BMessage(ABOUT_NEWT)));
	filemenu->AddItem(new BMenuItem("Quit", new BMessage(B_QUIT_REQUESTED)));

	rootsmenu->AddItem(new BMenuItem("Roots=3", new BMessage(3)));
	rootsmenu->AddItem(new BMenuItem("Roots=4", new BMessage(4)));
	rootsmenu->AddItem(new BMenuItem("Roots=5", new BMessage(5)));
	rootsmenu->AddItem(new BMenuItem("Roots=6", new BMessage(6)));
	rootsmenu->AddItem(new BMenuItem("other", new BMessage(OTHER_ROOT)));
	
	
	aView->Draw(aRect);

}

bool NewtonWindow::QuitRequested()
{
	be_app->PostMessage(B_QUIT_REQUESTED);
	
	return(true);
}

void NewtonWindow::MessageReceived(BMessage *message) {

  long result;
  BAlert *alert;
  char *aboutMesg="Newtown Fractal, ver. 0.3  Mikol Ryon, 2002";

  switch(message->what) {
  
	
    case B_QUIT_REQUESTED:
      be_app->PostMessage(B_QUIT_REQUESTED);
      break;
      
    case OTHER_ROOT:
	  alert=new BAlert("", "One of these days", "OK");
	  result=alert->Go();
	  break;
	  
    case ABOUT_NEWT:
	  alert=new BAlert("", aboutMesg, "OK");
	  result=alert->Go();
	  break;


    default:
      aView->roots=message->what;		// yeah yeah, potentialy bad. fix later
      aView->UpdateMe();
      aView->Draw(aRect);
      BWindow::MessageReceived(message);
  }
}


int main(int argc, char* argv[])
{	
	NewtonApplication	myApplication;
	
	srand(245171);	//seed the random number generator.
	
	myApplication.Run();
	return(0);
}

NewtonApplication::NewtonApplication()
		  		  : BApplication("application/x-vnd.Be-NewtonFractal")
{
	NewtonWindow		*aWindow;
	BRect			aRect;

	aRect.Set(100, 100, 300, 300 + MENU_BAR_HEIGHT + 1.0);
	aWindow = new NewtonWindow(aRect);
			
	aWindow->Show();
}
